/* Sistemas Integrados TECNISA

Nome: 0000_FINTMP_ATUALIZA_FINANCEIRO.SQL

Descrio:
Script para atualizao de dados dos sistemas financeiro [PAG - REC - BCO]

Criao:
27/06/02 - Jenilson Ferreira

Chamada para execuo:
 @C:\WIN_V2\SQL\END_CONV\ORACLE\0000_FINTMP_ATUALIZA_FINANCEIRO.SQL

*/


/* Corrige o fluxo de caixa dos ajustes dos boletos baixados */
DECLARE
   V_IDSTATUS VARCHAR2(1);
BEGIN
   FOR C_AJBOLPAG IN (SELECT AJ.CDEMPRESA,    AJ.CDFILIAL,
                             AJ.CDCLASSFINA,  AJ.DTMOVFLUXO,
                             AJ.IDMOVFLUXO,   AJ.CDFILIBOLPAG,
                             AJ.NRLANBOLPAG,  AJ.CDAJUCTPAG,
                             AJ.VRFXAJBOLPAG, TJ.IDAJUCTPAG,
                             BP.DTBAIXAPAG,   BP.IDSTATUSBPAG
                          FROM
                             BAIXAPAGA   BP, BOLETPAGAR  BO,
                             MOVFXAJBOLP AJ, TIPOAJPAGAR TJ
                          WHERE
                             BP.CDFILIAL     = BO.CDFILIBAIPAG AND
                             BP.NRBAIXAPAG   = BO.NRBAIXAPAG   AND
                             BO.CDFILIAL     = AJ.CDFILIBOLPAG AND
                             BO.NRLANBOLPAG  = AJ.NRLANBOLPAG  AND
                             AJ.CDAJUCTPAG   = TJ.CDAJUCTPAG) LOOP

      IF ((C_AJBOLPAG.DTMOVFLUXO <> C_AJBOLPAG.DTBAIXAPAG) OR
         (C_AJBOLPAG.IDMOVFLUXO = 'E' AND C_AJBOLPAG.IDSTATUSBPAG = 'E')) THEN

         IF C_AJBOLPAG.IDSTATUSBPAG = 'E' THEN
            V_IDSTATUS := 'R';
         ELSE
            V_IDSTATUS := 'E';
         END IF;

         /* - ATUALIZA O FLUXO DE CAIXA -------------------------- */
         IF C_AJBOLPAG.IDAJUCTPAG = 'A' THEN
            ATUALIZA_FLUXO_DE_CAIXA(C_AJBOLPAG.CDEMPRESA,
                                    C_AJBOLPAG.CDFILIAL,
                                    C_AJBOLPAG.DTMOVFLUXO,
                                    C_AJBOLPAG.IDMOVFLUXO,
                                    C_AJBOLPAG.CDCLASSFINA,
                                    0,
                                    C_AJBOLPAG.VRFXAJBOLPAG * -1);

            ATUALIZA_FLUXO_DE_CAIXA(C_AJBOLPAG.CDEMPRESA,
                                    C_AJBOLPAG.CDFILIAL,
                                    C_AJBOLPAG.DTBAIXAPAG,
                                    V_IDSTATUS,
                                    C_AJBOLPAG.CDCLASSFINA,
                                    0,
                                    C_AJBOLPAG.VRFXAJBOLPAG);
         ELSE
            ATUALIZA_FLUXO_DE_CAIXA(C_AJBOLPAG.CDEMPRESA,
                                    C_AJBOLPAG.CDFILIAL,
                                    C_AJBOLPAG.DTMOVFLUXO,
                                    C_AJBOLPAG.IDMOVFLUXO,
                                    C_AJBOLPAG.CDCLASSFINA,
                                    0,
                                    C_AJBOLPAG.VRFXAJBOLPAG);

            ATUALIZA_FLUXO_DE_CAIXA(C_AJBOLPAG.CDEMPRESA,
                                    C_AJBOLPAG.CDFILIAL,
                                    C_AJBOLPAG.DTBAIXAPAG,
                                    V_IDSTATUS,
                                    C_AJBOLPAG.CDCLASSFINA,
                                    0,
                                    C_AJBOLPAG.VRFXAJBOLPAG * -1);
         END IF;

         UPDATE MOVFXAJBOLP
         SET
            IDMOVFLUXO = V_IDSTATUS,
            DTMOVFLUXO = C_AJBOLPAG.DTBAIXAPAG
         WHERE
            CDEMPRESA    = C_AJBOLPAG.CDEMPRESA    AND
            CDFILIAL     = C_AJBOLPAG.CDFILIAL     AND
            CDCLASSFINA  = C_AJBOLPAG.CDCLASSFINA  AND
            DTMOVFLUXO   = C_AJBOLPAG.DTMOVFLUXO   AND
            IDMOVFLUXO   = C_AJBOLPAG.IDMOVFLUXO   AND
            CDFILIBOLPAG = C_AJBOLPAG.CDFILIBOLPAG AND
            NRLANBOLPAG  = C_AJBOLPAG.NRLANBOLPAG  AND
            CDAJUCTPAG   = C_AJBOLPAG.CDAJUCTPAG;
         COMMIT;
      END IF;
   END LOOP;
END;
/

/* Atualiza o fluxo de caixa com o novo Status 'P' Previsto */
DECLARE
   V_VRFLUXO NUMBER;
   V_QTFLUXO NUMBER;
BEGIN
   FOR C_CTREC IN (SELECT CR.CDFILIAL,    CR.NRLANCTONF,
                          CR.CDEMPRESA,   CR.CDFIMOVFLREC,
                          CR.CDCLASSFINA, CR.DTMOVFLUXO,
                          CR.IDMOVFLUXO,  SUM(CR.VRATUAREC) VRTOTCTREC
                   FROM CONTARECEBER CR,
                        NOTAFISCAL   NF
                   WHERE (CR.CDEMPRESA    IS NOT NULL) AND
                         (CR.CDFIMOVFLREC IS NOT NULL) AND
                         (CR.CDCLASSFINA  IS NOT NULL) AND
                         (CR.DTMOVFLUXO   IS NOT NULL) AND
                         (CR.IDMOVFLUXO   IS NOT NULL) AND
                         (CR.IDMOVFLUXO = 'E')         AND
                         (NF.IDSTATUS   = 'V')         AND
                         (NF.CDFILIAL   = CR.CDFILIAL) AND
                         (NF.NRLANCTONF = CR.NRLANCTONF)
                   GROUP BY CR.CDFILIAL,    CR.NRLANCTONF,
                            CR.CDEMPRESA,   CR.CDFIMOVFLREC,
                            CR.CDCLASSFINA, CR.DTMOVFLUXO,
                            CR.IDMOVFLUXO) LOOP

      SELECT COUNT(*), SUM(VRENTMFLUXO)
      INTO V_QTFLUXO,  V_VRFLUXO
      FROM MOVFLUXO
      WHERE CDEMPRESA   = C_CTREC.CDEMPRESA    AND
            CDFILIAL    = C_CTREC.CDFIMOVFLREC AND
            CDCLASSFINA = C_CTREC.CDCLASSFINA  AND
            DTMOVFLUXO  = C_CTREC.DTMOVFLUXO   AND
            IDMOVFLUXO  = 'P';

      IF V_QTFLUXO = 0 THEN
         INSERT INTO MOVFLUXO
           (CDCLASSFINA,
            CDEMPRESA,
            CDFILIAL,
            DTMOVFLUXO,
            IDMOVFLUXO,
            VRENTMFLUXO,
            VRSAIMFLUXO)
         VALUES
           (C_CTREC.CDCLASSFINA,
            C_CTREC.CDEMPRESA,
            C_CTREC.CDFIMOVFLREC,
            C_CTREC.DTMOVFLUXO,
            'P',
            C_CTREC.VRTOTCTREC,
            0);
      ELSE
         UPDATE MOVFLUXO
         SET VRENTMFLUXO = ROUND(V_VRFLUXO + C_CTREC.VRTOTCTREC, 2)
         WHERE CDCLASSFINA = C_CTREC.CDCLASSFINA  AND
               CDEMPRESA   = C_CTREC.CDEMPRESA    AND
               CDFILIAL    = C_CTREC.CDFIMOVFLREC AND
               DTMOVFLUXO  = C_CTREC.DTMOVFLUXO   AND
               IDMOVFLUXO  = 'P';
      END IF;

      UPDATE MOVFLUXO
      SET VRENTMFLUXO = ROUND(VRENTMFLUXO - C_CTREC.VRTOTCTREC, 2)
      WHERE CDCLASSFINA = C_CTREC.CDCLASSFINA  AND
            CDEMPRESA   = C_CTREC.CDEMPRESA    AND
            CDFILIAL    = C_CTREC.CDFIMOVFLREC AND
            DTMOVFLUXO  = C_CTREC.DTMOVFLUXO   AND
            IDMOVFLUXO  = C_CTREC.IDMOVFLUXO;

      UPDATE CONTARECEBER
      SET IDMOVFLUXO = 'P'
      WHERE CDCLASSFINA  = C_CTREC.CDCLASSFINA  AND
            CDEMPRESA    = C_CTREC.CDEMPRESA    AND
            CDFIMOVFLREC = C_CTREC.CDFIMOVFLREC AND
            DTMOVFLUXO   = C_CTREC.DTMOVFLUXO   AND
            IDMOVFLUXO   = C_CTREC.IDMOVFLUXO   AND
            CDFILIAL     = C_CTREC.CDFILIAL     AND
            NRLANCTONF   = C_CTREC.NRLANCTONF;
   END LOOP;
   COMMIT;
   FOR C_CTPAG IN (SELECT CP.CDFILIAL,    CP.NRLANCTONF,
                          CP.CDEMPRESA,   CP.CDFIMOVFLPAG,
                          CP.CDCLASSFINA, CP.DTMOVFLUXO,
                          CP.IDMOVFLUXO,  SUM(CP.VRATUAPAG) VRTOTCTPAG
                   FROM CONTAPAGAR CP,
                        NOTAFISCAL NF
                   WHERE (CP.CDEMPRESA    IS NOT NULL) AND
                         (CP.CDFIMOVFLPAG IS NOT NULL) AND
                         (CP.CDCLASSFINA  IS NOT NULL) AND
                         (CP.DTMOVFLUXO   IS NOT NULL) AND
                         (CP.IDMOVFLUXO   IS NOT NULL) AND
                         (CP.IDMOVFLUXO = 'E')         AND
                         (NF.IDSTATUS   = 'V')         AND
                         (NF.CDFILIAL   = CP.CDFILIAL) AND
                         (NF.NRLANCTONF = CP.NRLANCTONF)
                   GROUP BY CP.CDFILIAL,    CP.NRLANCTONF,
                            CP.CDEMPRESA,   CP.CDFIMOVFLPAG,
                            CP.CDCLASSFINA, CP.DTMOVFLUXO,
                            CP.IDMOVFLUXO) LOOP

      SELECT COUNT(*), SUM(VRSAIMFLUXO)
      INTO V_QTFLUXO,  V_VRFLUXO
      FROM MOVFLUXO
      WHERE CDEMPRESA   = C_CTPAG.CDEMPRESA    AND
            CDFILIAL    = C_CTPAG.CDFIMOVFLPAG AND
            CDCLASSFINA = C_CTPAG.CDCLASSFINA  AND
            DTMOVFLUXO  = C_CTPAG.DTMOVFLUXO   AND
            IDMOVFLUXO  = 'P';

      IF V_QTFLUXO = 0 THEN
         INSERT INTO MOVFLUXO
           (CDCLASSFINA,
            CDEMPRESA,
            CDFILIAL,
            DTMOVFLUXO,
            IDMOVFLUXO,
            VRENTMFLUXO,
            VRSAIMFLUXO)
         VALUES
           (C_CTPAG.CDCLASSFINA,
            C_CTPAG.CDEMPRESA,
            C_CTPAG.CDFIMOVFLPAG,
            C_CTPAG.DTMOVFLUXO,
            'P',
            0,
            C_CTPAG.VRTOTCTPAG);
      ELSE
         UPDATE MOVFLUXO
         SET VRSAIMFLUXO = ROUND(V_VRFLUXO + C_CTPAG.VRTOTCTPAG, 2)
         WHERE CDCLASSFINA = C_CTPAG.CDCLASSFINA  AND
               CDEMPRESA   = C_CTPAG.CDEMPRESA    AND
               CDFILIAL    = C_CTPAG.CDFIMOVFLPAG AND
               DTMOVFLUXO  = C_CTPAG.DTMOVFLUXO   AND
               IDMOVFLUXO  = 'P';
      END IF;

      UPDATE MOVFLUXO
      SET VRSAIMFLUXO = ROUND(VRSAIMFLUXO - C_CTPAG.VRTOTCTPAG, 2)
      WHERE CDCLASSFINA = C_CTPAG.CDCLASSFINA  AND
            CDEMPRESA   = C_CTPAG.CDEMPRESA    AND
            CDFILIAL    = C_CTPAG.CDFIMOVFLPAG AND
            DTMOVFLUXO  = C_CTPAG.DTMOVFLUXO   AND
            IDMOVFLUXO  = C_CTPAG.IDMOVFLUXO;

      UPDATE CONTAPAGAR
      SET IDMOVFLUXO = 'P'
      WHERE CDCLASSFINA  = C_CTPAG.CDCLASSFINA  AND
            CDEMPRESA    = C_CTPAG.CDEMPRESA    AND
            CDFIMOVFLPAG = C_CTPAG.CDFIMOVFLPAG AND
            DTMOVFLUXO   = C_CTPAG.DTMOVFLUXO   AND
            IDMOVFLUXO   = C_CTPAG.IDMOVFLUXO   AND
            CDFILIAL     = C_CTPAG.CDFILIAL     AND
            NRLANCTONF   = C_CTPAG.NRLANCTONF;
   END LOOP;
   COMMIT;
END;
/
